# frozen_string_literal: true

#
module LostInTranslation
  def self.diff(root, compared, lang1, lang2, structure = [], new_array = [], options = {})
    @slave_file = options[:slave_file] || ''
    @mode = options[:mode] || 'count' # replace, clean, count
    @diff_count = options[:diff_count] || 0
    @diff_counter = options[:diff_counter] || 0
    root.each_pair do |key, value|
      next_root     = root[key]
      next_compared = compared.nil? ? nil : compared[key]
      new_structure = structure.dup << key
      if value.is_a?(String) && (compared.nil? || compared[key].nil?)
        if value_missing(@slave_file, new_structure)
          @diff_counter += 1
          if @mode == 'replace'
            new_val = ask_for_translation(value, new_structure, lang1, lang2, @diff_count, @diff_counter)
            new_array << new_val unless new_val.blank?
          elsif @mode == 'clean'
            new_array << "#{new_structure.join('---')}---#{value}"
          end
        end
      end
      if next_root.is_a? Hash
        diff(next_root, next_compared, lang1, lang2, new_structure, new_array,
             diff_counter: @diff_counter, diff_count: @diff_count, mode: @mode, slave_file: @slave_file)
      end
    end
    @mode == 'count' ? @diff_counter : new_array
  end

  def self.value_missing(slave_file, structure)
    return true if slave_file.blank?
    slave_file.dig(*structure).blank?
  end

  def self.get_locale(path)
    path.split('/').last.split('.').first unless path.empty?
  end
end
