# frozen_string_literal: true

#
module LostInTranslation
  def self.string_to_hash(string)
    array = string.split('---')
    value = array.pop
    arr = array.reverse
    arr[1..-1].inject(arr[0] => value) { |memo, i| { i => memo } }
  end

  def self.merge_hash(merge_from, merge_to)
    return if merge_from.is_a?(String) || merge_to.is_a?(String)
    merged_hash = merge_to
    first_key = merge_from.keys.first
    merged_hash[first_key] = if merge_to.key?(first_key)
                               merge_hash(merge_from[first_key], merge_to[first_key])
                             else
                               merge_from[first_key]
                             end
    merged_hash
  end

  def self.sort_hash(object)
    return object unless object.is_a?(Hash)
    hash = {}
    object.each { |k, v| hash[k] = sort_hash(v) }
    sorted = hash.sort { |a, b| a[0].to_s <=> b[0].to_s }
    hash.class[sorted]
  end
end
