# frozen_string_literal: true

require 'lit/difference'
require 'lit/file_functions'
require 'lit/hash'
require 'lit/user_interface'
require 'lit/railties'

require 'tasks/compare'
require 'tasks/delete_missing'
require 'tasks/fully_automatic'
require 'tasks/half_automatic'
require 'tasks/recent'
require 'tasks/sort_file'
require 'tasks/split_file'
require 'tasks/start'
require 'tasks/count'

module LostInTranslation
  def self.root
    File.dirname __dir__
  end

  def self.tmp_paths
    tmp_paths = {}
    tmp_paths[:copy] = "#{root}/tmp/tmp_master_copy.yml"
    tmp_paths[:master] = "#{root}/tmp/tmp_master.yml"
    tmp_paths[:slave] = "#{root}/tmp/tmp_slave.yml"
    tmp_paths
  end

  def self.init(with_slave = true)
    system 'clear'
    log
    log 'What I18n-yaml files do you want to compare?'
    namespace = [(print "# Namespace? ('namespace' for 'namespace.en.yml'): "), Readline.readline()][1]
    master = ask_for_file(true, namespace) # lang path app_name
    slave = with_slave ? ask_for_file(false, namespace) : {}
    invalid_filepath if !File.exist?(master[:path]) && (!File.exist?(slave[:path]) && with_slave)
    [master, slave, tmp_paths]
  end

  def self.breakout
    raise "Well in that case, forget it!"
  end

  def self.invalid_filepath
    raise "One on the filepaths are invalid!"
  end

  def self.tbd
    raise "This feature is not yet implemented! Please take another!"
  end
end

class Lit
  extend LostInTranslation
end
