# frozen_string_literal: true

module LostInTranslation
  def self.count
    @master, @slave, paths = init

    prepare_for_edit(master: @master[:path], slave: @slave[:path])
    prepare_paths([paths[:master], paths[:slave]])

    master_file = YAML.load_file(paths[:master])
    slave_file = YAML.load_file(paths[:slave])

    count = diff(master_file[@master[:lang]], slave_file[@slave[:lang]], @master[:lang], @slave[:lang],
                 [@slave[:lang]], [], mode: 'count')

    count2 = diff(slave_file[@slave[:lang]], master_file[@master[:lang]], @slave[:lang], @master[:lang],
                  [@master[:lang]], [], mode: 'count')


    reset_tmp_files
    log
    log 'Differences between Locales'
    log "#{@master[:filename]}.yml => #{@slave[:filename]}.yml = #{count}"
    log "#{@slave[:filename]}.yml => #{@master[:filename]}.yml = #{count2}"
    log 'Done'
    log
  end
end
