# frozen_string_literal: true

module LostInTranslation
  def self.delete_missing
    tbd
    @master, @slave, paths = init

    prepare_for_edit(master: @master[:path], slave: @slave[:path])
    prepare_paths([paths[:master], paths[:slave]])

    master_file = YAML.load_file(paths[:master])
    slave_file = YAML.load_file(paths[:slave])

    breakout unless ask_for_permission(@master, count, @slave)

    new_strings_array = diff(master_file[@master[:lang]], slave_file[@slave[:lang]], @master[:lang],
                             @slave[:lang], [@slave[:lang]], [], mode: 'clean')

    master_file = {}
    new_strings_array.each do |string|
      string = string.split('---').map { |x| x == @slave[:lang] ? @master[:lang] : x }.join('---')
      result = string_to_hash(string)
      merge_hash(result, master_file)
    end

    File.open(@master[:path], 'w') { |file| file.write(master_file.to_yaml) }
    postpare_paths([@master[:path], @slave[:path]])
    reset_tmp_files
    log 'Done'
    log
  end
end
