# frozen_string_literal: true

module LostInTranslation
  def self.fully_automatic
    tbd
    @master, @slave, paths = init

    prepare_for_edit(master: @master[:path], slave: @slave[:path])
    prepare_paths([paths[:master], paths[:slave]])

    master_file = YAML.load_file(paths[:master])
    slave_file = YAML.load_file(paths[:slave])

    count = diff(master_file[@master[:lang]], slave_file[@slave[:lang]], @master[:lang],
                 @slave[:lang], [@slave[:lang]], [], mode: 'count')

    breakout unless ask_for_permission(@master, count, @slave)

    new_strings_array = diff(master_file[@master[:lang]], slave_file[@slave[:lang]], @master[:lang],
                             @slave[:lang], [@slave[:lang]], [], diff_count: count, mode: 'replace')

    new_strings_array.each do |string|
      result = string_to_hash(string)
      merge_hash(result, slave_file)
    end

    File.open(paths[:slave], 'w') { |file| file.write(slave_file.to_yaml(line_width: -1)) }
    postpare_paths([paths[:slave]])
    FileUtils.cp(paths[:slave], @slave[:path])

    reset_tmp_files
  end
end
