# frozen_string_literal: true

module LostInTranslation
  def self.recent
    @master, @slave, paths = init

    FileUtils.cp(@master[:path], paths[:copy])
    `git checkout "#{@master[:path]}"`

    prepare_for_edit(master: @master[:path], slave: @slave[:path])
    FileUtils.cp(paths[:copy], @master[:path])

    prepare_paths([paths[:master], paths[:slave], paths[:copy]])

    master_file = YAML.load_file(paths[:master])
    master_copy_file = YAML.load_file(paths[:copy])
    slave_file = YAML.load_file(paths[:slave])

    count = diff(master_copy_file[@master[:lang]], master_file[@master[:lang]], @master[:lang],
                 @slave[:lang], [@slave[:lang]], [], mode: 'count', slave_file: slave_file)

    breakout unless ask_for_permission(@master, count, @slave)

    new_strings_array = diff(master_copy_file[@master[:lang]], master_file[@master[:lang]], @master[:lang],
                             @slave[:lang], [@slave[:lang]], [], mode: 'replace', diff_counter: 0, diff_count: count,
                             slave_file: slave_file)

    new_strings_array.each do |string|
      result = string_to_hash(string)
      merge_hash(result, slave_file)
    end

    File.open(paths[:slave], 'w') { |file| file.write(slave_file.to_yaml(line_width: -1)) }
    postpare_paths([paths[:slave]])
    FileUtils.cp(paths[:slave], @slave[:path])

    reset_tmp_files
    log 'Done'
    log
  end
end
