# frozen_string_literal: true

module LostInTranslation
  def self.sort_file
    @master, @slave, paths = init(false)

    prepare_for_edit(master: @master[:path], slave: @slave[:path])
    prepare_paths([paths[:master]])

    master_file = YAML.load_file(paths[:master])

    if ask_for_sorting(@master[:lang], @master[:app_name])
      master_file = sort_hash(master_file)
      File.open(paths[:master], 'w') { |file| file.write(master_file.to_yaml(line_width: -1)) }
    end

    postpare_paths([paths[:master]])

    FileUtils.cp(paths[:master], @master[:path])

    reset_tmp_files
    log 'Done'
    log
  end
end
