# frozen_string_literal: true

module LostInTranslation
  def self.start
    tasks = [
      { text: 'Compare & Translate two I18n-Locale-Files', method: :start_compare },
      { text: 'Count Differences of 2 I18n-Locale-Files', method: :count },
      { text: 'Sort an I18n-Locale-File Alphabetically & Recursive (ASC)', method: :sort_file },
      { text: 'Split an I18n-Locale-File into multiple namespaced Files (1. Level)', method: :split_file },
      { text: 'Show a list of available I18n-Locale-Files', method: :list_files },
      { text: 'Tell me joke', method: :joke },
      { text: 'Quit', method: :quit }
    ]
    task = ask_for_task(tasks)
    LostInTranslation.send(task[:method])
  end

  def self.start_compare
    tasks = [
      { text: 'Compare everything', method: :compare },
      { text: 'Just compare the recent changes (since last git commit)', method: :recent },
      { text: 'Automatic translation via API', method: :fully_automatic },
      { text: 'Translation suggentions from API', method: :half_automatic },
      { text: 'Compare and delete the differences', method: :delete_missing },
    ]
    task = ask_for_task(tasks)
    LostInTranslation.send(task[:method])
  end

  def self.joke
    system 'clear'
    log
    log 'A: Knock, Knock!'
    log 'B: Who is there?'
    log 'A: Ya.'
    log 'B: Ya who?'
    log 'A: Oh, I prefer google.'
    log
  end

  def self.quit
    system 'clear'
    log
    log 'Thank you and goodbye!'
    log
  end

  def self.list_files
    system 'clear'

    path = ask_for_locales_path
    files = Dir["#{path}/**/*.yml"]
    puts "No Files found in #{path}" if files.empty?
    files&.sort&.each do |file|
      puts file.split('/').last
    end
    start
  end
end
