require 'lost_in_translation'

namespace :lit do
  desc 'Make the locale-yamls equal again(Interactive)'
  task :compare do
    system 'clear'
    LostInTranslation.compare
  end

  desc 'Just start and get lead through the process'
  task :start do
    system 'clear'
    LostInTranslation.start
  end

  desc 'Use Translator-Engine as a suggestion for translation'
  task :half_automatic do
    LostInTranslation.half_automatic
  end

  desc 'Use Translator-Engine to automatically translate everything'
  task :fully_automatic do
    LostInTranslation.fully_automatic
  end

  desc 'Split big files in many small ones'
  task :split_file do
    LostInTranslation.split_file
  end

  desc 'Sort Locale-File recursively'
  task :sort_file do
    LostInTranslation.sort_file
  end

  desc 'Cleaning out the Yaml-Closet'
  task :delete_missing do
    LostInTranslation.delete_missing
  end

  desc 'Tranlate just your recently changed Strings(requires git)'
  task :recent do
    abort('Please use this feature inside a Rails-Application') unless defined? Rails
    LostInTranslation.recent
  end
end
